SystemOrganization addCategory: #'Magritte-Morph-Core'!

!MABooleanDescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 5/26/2005 19:28'!
defaultMorphClasses
	^ Array with: MACheckboxMorph.! !

!MAMagnitudeDescription class methodsFor: '*Magritte-Morph-default' stamp: 'lr 5/8/2005 20:33'!
defaultMorphClasses
	^ Array with: MATextLineMorph.! !

!MAContainer class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultMorphClasses
	^ Array with: MAContainerMorph.! !

Object subclass: #MADescriptionMorph
	instanceVariableNames: 'memento morph answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

MADescriptionMorph subclass: #MAContainerMorph
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

!MAContainerMorph methodsFor: 'private' stamp: 'lr 5/8/2005 20:30'!
buildChildren
	^ Array streamContents: [ :stream |
		self description do: [ :each |
			each isVisible ifTrue: [
				stream nextPut: (each 
					asMorphOn: self value) ] ] ].! !

!MAContainerMorph methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
children
	^ children ifNil: [ children := self buildChildren ].! !

!MAContainerMorph methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
commit
	self children do: [ :each | each commit ].
	super commit.! !

!MAContainerMorph methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
reset
	self children do: [ :each | each reset ].
	super reset.! !

!MAContainerMorph methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
validate
	self children do: [ :each | each validate ].
	super validate.! !

!MAContainerMorph methodsFor: 'morphic' stamp: 'lr 5/8/2005 20:30'!
viewerMorph
	| container |
	container := self rectangleMorph
		setBalloonText: self description comment;
		cellInset: 3;
		listDirection: #topToBottom;
		yourself.
	self children do: [ :each |
		container addMorphBack: each morph ].
	^ container.! !

!MADescriptionMorph class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
memento: aMemento
	^ self new
		setMemento: aMemento;
		yourself.! !

!MADescriptionMorph class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
model: aModel
	^ self model: aModel description: aModel description.! !

!MADescriptionMorph class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
model: aModel description: aDescription
	^ self memento: (aModel defaultWrapperClass on: aDescription model: aModel).! !

!MADescriptionMorph methodsFor: 'actions-conveniance' stamp: 'lr 5/8/2005 20:30'!
accept
	[ self validate ] 
		on: Error
		do: [ :err | ^ self inform: err messageText ].
	self commit; answer: self value.! !

!MADescriptionMorph methodsFor: 'adding' stamp: 'lr 5/8/2005 20:30'!
addButtons
	self addButtons: #( accept cancel ).! !

!MADescriptionMorph methodsFor: 'adding' stamp: 'lr 5/8/2005 20:30'!
addButtons: anArray
	morph := self rectangleMorph
		listDirection: #topToBottom;
		addMorphBack: self morph;
		addMorphBack: (self barMorph: anArray);
		yourself.! !

!MADescriptionMorph methodsFor: 'adding' stamp: 'lr 5/8/2005 20:30'!
addWindow
	self morph layoutInset: 5@5.
	morph := self windowMorph
		model: self;
		vResizing: #shrinkWrap;
		
		addMorph: self morph frame: (0 @ 0 corner: 1 @ 1);
		yourself.! !

!MADescriptionMorph methodsFor: 'answering' stamp: 'lr 5/8/2005 20:30'!
answer: anObject
	answer isNil
		ifFalse: [ answer value: anObject ].
	self morph delete.! !

!MADescriptionMorph methodsFor: 'private' stamp: 'lr 5/8/2005 20:30'!
arrowKey: aCharacter from: aMorph! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 5/8/2005 20:30'!
barMorph: anArray
	| bar |
	bar := self rectangleMorph
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		listDirection: #leftToRight;
		listCentering: #center;
		wrapCentering: #bottomRight;
		cellInset: self defaultSpacerSize;
		yourself.
	anArray do: [ :selector |
		bar addMorphBack: (self buttonMorph: selector) ].
	^ bar.! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 5/8/2005 20:30'!
buttonMorph: aSelector
	| button |
	button := PluggableButtonMorph
		on: self 
		getState: #buttonState 
		action: aSelector.
	button
		label: aSelector;
		shortcutCharacter: aSelector first;
		onColor: Color transparent offColor: Color white;
		useRoundedCorners;
		borderWidth: 2;
		borderColor: #raised.
	^ button.! !

!MADescriptionMorph methodsFor: 'private' stamp: 'lr 5/8/2005 20:30'!
buttonState
	^ true! !

!MADescriptionMorph methodsFor: 'opening' stamp: 'lr 6/10/2005 17:23'!
callInHand
	self onAnswer: [ :value | ^ value ].
	self openInHand; waitUntilClosed.! !

!MADescriptionMorph methodsFor: 'opening' stamp: 'lr 6/10/2005 17:23'!
callInWorld
	self onAnswer: [ :value | ^ value ].
	self openInWorld; waitUntilClosed.! !

!MADescriptionMorph methodsFor: 'actions-conveniance' stamp: 'lr 5/8/2005 20:30'!
cancel
	self answer: nil.! !

!MADescriptionMorph methodsFor: 'actions-conveniance' stamp: 'lr 5/8/2005 20:30'!
close
	self cancel.! !

!MADescriptionMorph methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
commit
	self description isReadonly
		ifFalse: [ self memento commit ].! !

!MADescriptionMorph methodsFor: 'morphic' stamp: 'lr 5/8/2005 20:30'!
composedMorph
	^ self editorMorph.! !

!MADescriptionMorph methodsFor: 'accessing-configuration' stamp: 'lr 5/8/2005 20:30'!
defaultBackgroundColor
	^ self description morphColor.! !

!MADescriptionMorph methodsFor: 'accessing-configuration' stamp: 'lr 5/8/2005 20:30'!
defaultSpacerSize
	^ 5! !

!MADescriptionMorph methodsFor: 'accessing-dynamic' stamp: 'lr 5/9/2005 13:31'!
description
	^ self memento description.! !

!MADescriptionMorph methodsFor: 'morphic' stamp: 'lr 5/8/2005 20:30'!
editorMorph
	^ self viewerMorph.! !

!MADescriptionMorph methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
memento
	^ memento! !

!MADescriptionMorph methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:30'!
model
	^ self memento model.! !

!MADescriptionMorph methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:30'!
morph
	^ morph ifNil: [ morph := self composedMorph ].! !

!MADescriptionMorph methodsFor: 'answering' stamp: 'lr 5/8/2005 20:30'!
onAnswer: aBlock
	answer := aBlock! !

!MADescriptionMorph methodsFor: 'opening' stamp: 'lr 5/8/2005 20:30'!
openInHand
	^ self morph openInHand.! !

!MADescriptionMorph methodsFor: 'opening' stamp: 'lr 5/8/2005 20:30'!
openInWorld
	^ self morph openInWorld.! !

!MADescriptionMorph methodsFor: 'private' stamp: 'lr 5/8/2005 20:30'!
perform: selector orSendTo: otherTarget
	^ (self respondsTo: selector)
		ifTrue: [ self perform: selector ]
		ifFalse: [ otherTarget perform: selector ].! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 5/8/2005 20:30'!
rectangleMorph
	^ RectangleMorph new
		borderWidth: 0;
		color: Color transparent;
		layoutPolicy: TableLayout new;
		cellPositioning: #topLeft;
		vResizing: #shrinkWrap;
		hResizing: #spaceFill;
		yourself.! !

!MADescriptionMorph methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
reset
	self memento reset.! !

!MADescriptionMorph methodsFor: 'actions-conveniance' stamp: 'lr 5/8/2005 20:30'!
save
	self accept.! !

!MADescriptionMorph methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
setMemento: aMemento
	memento := aMemento! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 5/8/2005 20:30'!
stringMorph
	^ StringMorph new.! !

!MADescriptionMorph methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
validate
	self memento validate.! !

!MADescriptionMorph methodsFor: 'accessing-memento' stamp: 'lr 5/8/2005 20:30'!
value
	^ self memento value.! !

!MADescriptionMorph methodsFor: 'accessing-memento' stamp: 'lr 5/8/2005 20:30'!
value: anObject
	self memento value: anObject.! !

!MADescriptionMorph methodsFor: 'morphic' stamp: 'lr 5/8/2005 20:30'!
viewerMorph
	^ self stringMorph
		contents: self value asLabel;
		yourself.! !

!MADescriptionMorph methodsFor: 'private' stamp: 'lr 5/8/2005 20:30'!
waitUntilClosed
	[ self morph world notNil ]
		whileTrue: [ self morph outermostWorldMorph doOneCycle ].! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 5/8/2005 20:30'!
windowMorph
	^ SystemWindow labelled: self description label.! !

MADescriptionMorph subclass: #MAElementMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

MAElementMorph subclass: #MACheckboxMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

!MACheckboxMorph methodsFor: 'morphic' stamp: 'lr 5/26/2005 19:25'!
editorMorph
	^ ThreePhaseButtonMorph checkBox
		target: self;
		actionSelector: #toggle;
		getSelector: #value;
		yourself.! !

!MACheckboxMorph methodsFor: 'actions' stamp: 'lr 5/26/2005 19:26'!
toggle
	self value: self value not.! !

!MAElementMorph methodsFor: 'morphic' stamp: 'lr 5/8/2005 20:31'!
composedMorph
	| composed |
	composed := self rectangleMorph
		layoutInset: 1 @ 1;
		listDirection: #leftToRight;
		setBalloonText: self description comment;
		addMorphBack: self labelMorph;
		addMorphBack: (self description isReadonly
			ifTrue: [ self viewerMorph ]
			ifFalse: [ self editorMorph ]);
		yourself.
	self description isRequired
		ifTrue: [ composed addMorphBack: self requiredMorph ].
	^ composed.! !

!MAElementMorph methodsFor: 'morphic' stamp: 'lr 5/8/2005 20:31'!
labelMorph
	^ self stringMorph
		contents: self description label , ':';
		width: 100;
		yourself.! !

!MAElementMorph methodsFor: 'morphic' stamp: 'lr 5/8/2005 20:31'!
requiredMorph
	^ self stringMorph
		contents: ' *';
		color: Color red;
		yourself.! !

!MAElementMorph methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
string
	^ self description toString: self value.! !

!MAElementMorph methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
string: aString
	self value: (self description parseString: aString).
	self changed: #string.! !

MAElementMorph subclass: #MAListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

!MAListMorph methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
options
	^ self description allOptions! !

MAListMorph subclass: #MAMultipleListMorph
	instanceVariableNames: 'primary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

!MAMultipleListMorph methodsFor: 'morphic' stamp: 'lr 5/8/2005 20:31'!
editorMorph
	^ (PluggableListMorphOfMany
		on: self
		list: #options 
		primarySelection: #primary
		changePrimarySelection: #primary: 
		listSelection: #value
		changeListSelection: #value:
		menu: #menu)
		hResizing: #spaceFill;
		borderColor: #inset;
		borderWidth: 2;
		yourself.! !

!MAMultipleListMorph methodsFor: 'private' stamp: 'lr 5/8/2005 20:31'!
menu
	^ nil! !

!MAMultipleListMorph methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
primary
	^ primary! !

!MAMultipleListMorph methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
primary: anObject
	primary := anObject! !

MAListMorph subclass: #MASingleListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

!MASingleListMorph methodsFor: 'morphic' stamp: 'lr 5/8/2005 20:32'!
editorMorph
	^ (PluggableListMorph on: self list: #options selected: #selected changeSelected: #selected:)
		hResizing: #spaceFill;
		borderColor: #inset;
		borderWidth: 2;
		yourself.! !

!MASingleListMorph methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
selected
	^ self options indexOf: self value.! !

!MASingleListMorph methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
selected: anInteger
	self value: (self options at: anInteger ifAbsent: nil).
	self changed: #selected.! !

MAElementMorph subclass: #MATextAreaMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

!MATextAreaMorph methodsFor: 'morphic' stamp: 'lr 5/8/2005 20:33'!
editorMorph
	^ (PluggableTextMorph on: self text: #string accept: #string:)
		hResizing: #spaceFill;
		borderColor: #inset;
		borderWidth: 2;
		yourself.! !

!MATextAreaMorph methodsFor: 'actions' stamp: 'lr 5/8/2005 20:33'!
validate
	self morph allMorphsDo: [ :each | 
		(each respondsTo: #accept)
			ifTrue: [ each accept ] ].
	super validate.! !

MATextAreaMorph subclass: #MATextLineMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

!MATextLineMorph methodsFor: 'morphic' stamp: 'lr 5/8/2005 20:33'!
editorMorph
	^ super editorMorph
		hideScrollBarsIndefinitely: true;
		acceptOnCR: true;
		height: 20;
		yourself.! !

!Object methodsFor: '*Magritte-Morph-converting' stamp: 'lr 5/8/2005 20:29'!
asMorph
	^ self description asMorphOn: self.! !

!MAMultipleSelectionDescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultMorphClasses
	^ Array with: MAMultipleListMorph.! !

!MAColorDescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 5/23/2005 20:36'!
defaultMorphClasses
	^ Array with: MAColorMorph.! !

!MATextDescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultMorphClasses
	^ Array with: MATextAreaMorph.! !

Exception subclass: #MATerminateProcess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

!MATerminateProcess methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:33'!
defaultAction
	" does nothing "
	Processor terminateActive! !

!MADescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultMorphClass
	^ self defaultMorphClasses first.! !

!MADescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultMorphClasses
	^ Array new.! !

!MADescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultMorphColor
	^ Color r: 0.151 g: 0.327 b: 0.720.! !

!MADescription class methodsFor: '*Magritte-Morph-description' stamp: 'lr 5/8/2005 20:33'!
descriptionMorphClass
	^ (MASingleSelectionDescription selector: #morphClass label: 'Morph Class' priority: 600)
		options: self defaultMorphClasses;
		beRequired;
		yourself.! !

!MADescription methodsFor: '*Magritte-Morph-converting' stamp: 'lr 5/8/2005 20:30'!
asMorphOn: anObject
	^ self morphClass model: anObject description: self.! !

!MADescription methodsFor: '*Magritte-Morph-accessing' stamp: 'lr 5/8/2005 20:30'!
morphClass
	^ self propertyAt: #morphClass ifAbsent: [ self class defaultMorphClass ].! !

!MADescription methodsFor: '*Magritte-Morph-accessing' stamp: 'lr 5/8/2005 20:30'!
morphClass: aClass
	^ self propertyAt: #morphClass put: aClass.! !

!MADescription methodsFor: '*Magritte-Morph-accessing' stamp: 'lr 5/8/2005 20:30'!
morphColor
	^ self propertyAt: #morphColor ifAbsent: [ self class defaultMorphColor ].! !

!MADescription methodsFor: '*Magritte-Morph-accessing' stamp: 'lr 5/8/2005 20:30'!
morphColor: aColor
	^ self propertyAt: #morphColor put: aColor.! !

!MAStringDescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultMorphClasses
	^ Array with: MATextLineMorph.! !

!MASingleSelectionDescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultMorphClasses
	^ Array with: MASingleListMorph.! !
